<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--<%@page import="imagemed.summaries.SummaryManager"%>
<%@page import="imagemed.summaries.Summary"%>
<%@
	page import="imagemed.actions.*,imagemed.util.*,imagemed.lists.GenericUserList,imagemed.http.IMRequest,imagemed.imsession.*,java.util.*,imagemed.exception.*,java.text.Format"
%><%@
	page errorPage="../main/exceptionHandler.jsp"
%><%!

	String checkedList( IMSession is, int listType, String user, String list, boolean hidden ) throws IMGeneralException {
		if ( !list.startsWith( user + "/" ) ) {
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_COMPOUND_DIFFERENT_USERS" ), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BAD_PARAMETER" ), "/cases/lists.jsp" );
		}
		if ( hidden != list.startsWith( user + "/." ) ) {
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_COMPOUND_HIDDEN_NONHIDDEN" ), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BAD_PARAMETER" ), "/cases/lists.jsp" );
		}
		int p = list.indexOf( "/" );
		String listUser = list.substring( 0, p );
		String listName = list.substring( p + 1 ); //
		if ( GenericUserList.isCompound( listType, listUser, listName ) ) {
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_NONCOMPOUND_BUILD_COMPOUND" ), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BAD_PARAMETER" ), "/cases/lists.jsp" );
		}
		return list;
	}

%><%
	IMSession is = new IMSession( request, response, out );

	is.regDest = "/cases/lists.jsp";
	if ( ! is.regOK() ) {
		return;
	}

%><%-- --- Input Parameters --- -- %><%

	IMRequest reqPar = is.imRequest;

	String parOper = reqPar.getVal( "cOper" );
	String parListUser = reqPar.getVal( "cListUser" );
	String backContext = reqPar.getVal( "cBackContext" );
	String parListName = Helper.decodeByRty( reqPar.getVal( "cListName" ) );
	String htmlUser = Helper.htmlEncode( parListUser );
	String htmlList = Helper.htmlEncode( parListName, true );
	String parSummary = null;

	boolean isAdmin = false;
	if ( is.regRights != null ) {
		isAdmin = is.regRights.indexOf( "A" ) != -1;
	}

	int listType = 0;
	try {
		listType = Integer.parseInt( reqPar.getVal( "cListType", "0" ) );
	}
	catch ( NumberFormatException nfe ) {
	}

	//only the admin can edit actions for groups lists, users can only overide lists
	if ( ( parListUser != null && parListUser.indexOf( "%23" ) != -1 ) && !isAdmin && parOper != null && !"Override".equals( parOper ) ) {
		String operMsg = LocalizedMessage.getSimpleMessage( "OPER_SENTENCE_" + parOper.replace(' ', '_' ).toUpperCase() );
		throw new IMGeneralException( is, LocalizedMessage.getCompoundMessage( "EXCEPTION_LISTOP_YOU_HAVE_NO_RIGHTS_TO_OPER_LISTS", new Format[] { null }, new Object[] { operMsg }, true), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_ADMIN_RIGHTS_NEEDED" ), "/cases/lists.jsp" );
	}
	
	if ( "Compound".equals( parOper ) ) {
		String user = null;
		if ( request.getParameterValues( "cGr" ) != null ) {
			String url = "";

			String[] compoundArray = request.getParameterValues( "cGr" );
			boolean isHidden = false;
			for ( int i = 0; i < compoundArray.length; i++ ) {
				String compoundTmp = compoundArray[ i ];
				if ( i == 0 ) {
					isHidden = compoundTmp.charAt( compoundTmp.indexOf( "/" ) + 1 ) == '.';
				}
				if ( compoundTmp != null && !compoundTmp.equals( "" ) ) {
					if ( user == null ) {
						int p = compoundTmp.indexOf( "/" );
						user = compoundTmp.substring( 0, p );
					}
					int p = compoundTmp.indexOf( ";" );
					while ( p > 0 ) {
						String next = compoundTmp.substring( 0, p );
						compoundTmp = compoundTmp.substring( p + 1 );
						url += checkedList( is, listType, user, next, isHidden ) + ";";
						p = compoundTmp.indexOf( ";" );
					}
					url += checkedList( is, listType, user, compoundTmp, isHidden ) + ";";
				}
			}
			if ( url.endsWith( ";" ) ) {
				url = url.substring( 0, url.length() - 1).replace( ';', '\n' );
			}
			else {
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_NOT_SELECTED_LISTS" ), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ), "/cases/lists.jsp" );
			}
			
%>
<script language="JavaScript">top.location="<%=GenericUserList.getPrimaryPage(listType)%>?cCompoundLists=<%=Helper.URLEncodeUTF8(url)%>";</script>
<%
			return;
		}
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_NOT_SELECTED_LISTS" ), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ), "/cases/lists.jsp" );
	} // Compound
	//  TabBean.writeStyleOnly(is);
	String filterParent = reqPar.getVal( "parentwindow" );
	if ( filterParent == null ) {
		filterParent = "filterParent";
	}
%><%-- --- HTML --- -- %><HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_LISTOP" ) %></title>
<%
	imagemed.tables.Table.printCommonScript( is );
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
%>
<script language="JavaScript">
	function doSubmit() {
		var chPurgeObjs = getelementbyid( 'purgeobjects' );
		if ((chPurgeObjs!=null) && (chPurgeObjs!= undefined) && (chPurgeObjs.checked) && (!isSubmitAllowed())){
			alert("No object filter is set. \nPlease define at least one object filter.");
			return;
		}
		form = document.forms[0];
		form.submit();
	}
	
	function isSubmitAllowed() {
		var i;
		var selectElements = document.getElementsByTagName("select");
		for (i=0; i<selectElements.length; i++){
			selectElementsName = selectElements[i].getAttribute("name");
		    if(selectElementsName.indexOf("f")==0){
		    	var selectElementsSelectedIndex = selectElements[i].selectedIndex;
		    	if(selectElementsSelectedIndex>=0){
		    		var selCheckboxes = filterCBHandlers[selectElementsName.substring(1, selectElementsName.length-3)].getSelCheckboxes()
		    		var k;
		    		for (k=0; k<selCheckboxes.length; k++)
		    		{
		    			if(selCheckboxes[k].isChecked()){
		    				return true;
		    			}
		    		}
		    	}
		    }
		}
		var inputElements = document.querySelectorAll("input[type=text]");
		for (i=0; i<inputElements.length; i++){
			inputElementsName = inputElements[i].getAttribute("name");
			inputElementsValue = inputElements[i].value;
			if( (inputElementsName.indexOf("f")==0) && (inputElementsValue!=null) && (inputElementsValue!="") ){
		    	var srcCheckboxes = filterCBHandlers[inputElementsName.substring(1, inputElementsName.length-3)].getSrcCheckboxes()
		    	var k;
		    	for (k=0; k<srcCheckboxes.length; k++)
	    		{
	    			if(srcCheckboxes[k].isChecked()){
	    				return true;
	    			}
	    		}
			}
		}
		return false;
	}
</script>
<%
	JSHelper.printJsInclude( out, "/cases/js/FilterScripts.js" );

	String parAct = null;
	if ( parOper.startsWith( "Configure" ) ) {
		DcAction[] actions = DcActionManager.getActions();
		parAct = parOper.substring( 10 );
		for ( int i = 0; i < actions.length; i++ ) {
			if ( actions[ i ].getName().equals( parAct ) ) {
				actions[ i ].printScripts( is );
			}
		}
	}
%>
</head>
<BODY>
<CENTER>
<%
	imagemed.jsputil.TabToolbox.makeTabs( is, is.tabbean, "cases/lists.jsp", "White" );
%> <font face="Arial,Helvetica,Universe">
<h3>
<FORM id="listopForm" name="operForm" METHOD="POST" ACTION='lists.jsp'>
<%
	boolean NO_DELETE = false;
	IMProperties imprp = new IMProperties();
	imprp.recRead(IMEnvBase.getEnv("CONF") + "/limit.conf");
	if ( !"false".equals( imprp.getProperty( "NO_DELETE", "false" ) ) ) {
		// 'true' or 'report'
		NO_DELETE = true;
	}

	if ( !parOper.equals( "BatchDel" ) && !parOper.equals( "Update Actions" ) ) {
		String operMsg = LocalizedMessage.getSimpleMessage( "OPER_SENTENCE_" + parOper.replace(' ', '_' ).toUpperCase() );
		Format[] msgFormat = new Format[] { null, null, null, null };
		Object[] msgObject = new Object[] { operMsg, LocalizedMessage.getSimpleMessage( GenericUserList.LIST_TYPE_GUI_NAMES[listType] ), htmlUser, htmlList };
		is.out.println( LocalizedMessage.getCompoundMessage( "CASES_LISTOP_YOU_ARE_ABOUT_TO_OPER_LIST", msgFormat, msgObject, true) );
		if ( NO_DELETE && "Configure Purge".equals( parOper ) ) {
			is.out.println("<p><div id=\"titleMessDiv\"><font color=red>" + LocalizedMessage.getSimpleMessage( "CASES_LISTOP_ENABLING_THIS_ACTION_PERMANENTLY_DELETE_STUDIES_FROM_SERVER" ) + "</font></div>");
		}
	}
%>
<p>
<%
	if (parOper.startsWith("Configure")) {
%>

<TABLE border=1 cellpadding=0 cellspacing=0>
		<%
			DcAction[] actions = DcActionManager.getActions();
				for (int i = 0; i < actions.length; i++)
					if (actions[i].getName().equals(parAct)) {
						actions[i].setList(parListUser, parListName);
						actions[i].printInput(is);
					}
				parOper = "Configure";
		%>
</table>
<%
	}
	else if (parOper.startsWith("SummaryConfigure")) {
		parSummary = parOper.substring( 17 );
%>
<TABLE border=1 cellpadding=0 cellspacing=0>
<%
		Summary[] summaries = SummaryManager.getSummaries( listType );
		for (int i = 0; i < summaries.length; i++) {
			if( summaries[ i ].getType().equals( parSummary ) ) {
				summaries[ i ].printInput( is, parListUser, listType, parListName );
			}
		}
		parOper = "SummaryConfigure";
%>
</table>
<%
	}
	else if( "Update Actions".equals( parOper ) ) {
		String txt = "<CENTER><TABLE border=1 cellpadding=0 cellspacing=0>";
		txt += Helper.header3D( LocalizedMessage.getSimpleMessage( "CASES_LISTS_LISTSAVING" ) ) + "<TR><TD>";
		txt += "<CENTER>" + LocalizedMessage.getCompoundMessage( "CASES_LISTS_OVEWRITE_MESSAGE", new Format[] { null }, new Object[] { parListName }, true ) + "<BR><BR>";
		txt += "<TABLE border=1 cellpadding=0 cellspacing=0 class=BgMedLight><TR><TD><CENTER>";
		txt += LocalizedMessage.getSimpleMessage( "CASES_LISTOP_OVEWRITING_MSG" );
		txt += ":<BR>";

		UserList userList = new UserList();
		userList.setListType( listType );
		userList.setListUserRights( is.regRights );
		userList.setUser( parListUser );
		userList.setList( parListName );
		
		List<String> actionNames = userList.getEnabledActionsNameList();
		txt += "<TABLE border=3 cellpadding=0 cellspacing=0 class=BgMedLight>";
		txt += "<TR><TH>Action</TH><TH>" + LocalizedMessage.getSimpleMessage( "CASES_LISTOP_APPLY_TO_CURRENT_CONTENT" ) + "</TH></TR>";
		for( int i = 0; i < actionNames.size(); i++ ) {
			txt += "<TR><TD>" + actionNames.get( i ) + "</TD><TD>";
			txt += "<INPUT TYPE=\"CHECKBOX\" NAME=\"ActionApply" + actionNames.get( i )+ "\" VALUE=\"Yes\">";
			txt += "</TD></TR>";
		}
		txt += "</TABLE><BR>";
		txt += "</TD></TR></TABLE>";
		txt += "</TD></TR></TABLE>";
		is.out.println( txt ); 
		parOper = "SaveOverWriteActions";
	}
	else if ("Rename".equals(parOper)) {
%> <%= LocalizedMessage.getSimpleMessage( "EXCEPTION_MESSAGES_NEW_LIST_NAME" ) %>: <INPUT type=text name=cNewName size=16 maxlength=32><br>
<%
	}
	else if ("Delete".equals(parOper)) {
		if (is.regRights.indexOf("A") == -1 && htmlUser.startsWith("#")) {
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_YOU_HAVE_NO_RIGHTS_TO_DELETE_LIST" ) + ": <br><center>" + htmlUser + ":" + htmlList + "</center>", "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_ADMIN_RIGHTS_NEEDED" ), "/cases/lists.jsp");
		}
		else {
%>
<p><%= LocalizedMessage.getSimpleMessage( "ARE_YOU_SURE" ) %><br>
<%
	}
	}
	else if ("Override".equals(parOper)) {
%>

<p><%= LocalizedMessage.getSimpleMessage ( "ARE_YOU_SURE" ) %><br>
<%
	}
	else if ("BatchDel".equals(parOper)) {
		List<String> listNames = new ArrayList<String>();
		List<String> listUsers = new ArrayList<String>();

		if (request.getParameterValues("cGr") != null) {
			String[] compoundArray = request.getParameterValues("cGr");

			for (int i = 0; i < compoundArray.length; i++) {
				String compoundTmp = compoundArray[i];
				if (compoundTmp != null && !compoundTmp.equals("")) {
					int p = compoundTmp.indexOf(";");
					while (p > 0) {
						String next = compoundTmp.substring(0, p);
						compoundTmp = compoundTmp.substring(p + 1);
						p = next.indexOf('/');

						listUsers.add(next.substring(0, p));
						listNames.add(next.substring(p + 1));

						p = compoundTmp.indexOf(";");
					}
					p = compoundTmp.indexOf('/');
					listUsers.add(compoundTmp.substring(0, p));
					listNames.add(compoundTmp.substring(p + 1));
				}
			}
		}
		if (listNames.size() == 0) {
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_NOT_SELECTED_LISTS" ), "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ), "/cases/lists.jsp" );
		}
		List<String> badCompLists = new ArrayList<String>();
		List<String> badCompListUsers = new ArrayList<String>();
		List<String> noRightsLists = new ArrayList<String>();
		List<String> noRightsListUsers = new ArrayList<String>();
		for (int i = 0; i < listNames.size(); i++) {
			String listName = listNames.get(i);
			String listUser = listUsers.get(i);
			if (!GenericUserList.isDeletable(listType, listUser, listName)) {
				badCompLists.add(listName);
				badCompListUsers.add(listUser);
			}
			else if ((listUser.startsWith("#") || listUser.startsWith("%")) && is.regRights.indexOf("A") == -1) {
				noRightsLists.add(listName);
				noRightsListUsers.add(listUser);
			}
		}
		if (badCompLists.size() > 0) {
			String message = (badCompLists.size() > 1) ? LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_LIST_REFERENCED_COMPOUND_PLURAL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_LIST_REFERENCED_COMPOUND" );
					
			message += "<br>\n<center><table border=1 cellpadding=0 cellspacing=0>";
			message += Helper.header3D("   " + LocalizedMessage.getSimpleMessage( "GENERIC_OWNER" ).toLowerCase() + "   ,   " + LocalizedMessage.getSimpleMessage( "GENERIC_NAME" ).toLowerCase() + "   ");
			for (int i = 0; i < badCompLists.size(); i++) {
				message += "<tr><td>" + badCompListUsers.get(i) + "</td><td>" + badCompLists.get(i) + "</td></tr>";
			}
			message += "</table></center>";
			throw new IMGeneralException(is, message, "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BAD_PARAMETER" ), "/cases/lists.jsp");
		}
		if (noRightsLists.size() > 0) {
			String message = (noRightsLists.size() > 1) ? LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_YOU_HAVE_INSUFFICIENTE_RIGHTS_TO_DELETE_PLURAL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_YOU_HAVE_INSUFFICIENTE_RIGHTS_TO_DELETE" );
			message += "<br>\n<center>\n<table border=1 cellpadding=0 cellspacing=0>";
			message += Helper.header3D("   " + LocalizedMessage.getSimpleMessage( "GENERIC_OWNER" ).toLowerCase() + "   ,   " + LocalizedMessage.getSimpleMessage( "GENERIC_NAME" ).toLowerCase() + "   ");
			for (int i = 0; i < noRightsLists.size(); i++) {
				message += "\n<tr><td>" + noRightsListUsers.get(i) + "</td><td>" + noRightsLists.get(i) + "</td></tr>";
			}
			message += "</table></center>";
			throw new IMGeneralException( is, message, "cases/lists.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTOP_ADMIN_RIGHTS_NEEDED" ), "/cases/lists.jsp");
		}
%>
<p>	<%= LocalizedMessage.getSimpleMessage( "CASES_LISTOP_BATCH_DELETE_MSG" ) %> 
	<%=(listNames.size() > 1 ? LocalizedMessage.getSimpleMessage( GenericUserList.LIST_TYPE_GUI_NAMES_PLURAL[listType] ) : LocalizedMessage.getSimpleMessage( GenericUserList.LIST_TYPE_GUI_NAMES[listType]) ) %>:

<TABLE border=1 cellpadding=0 cellspacing=0>
		<%
			out.println(Helper.header3D(LocalizedMessage.getSimpleMessage( "GENERIC_USER_ID" ) + "," + LocalizedMessage.getSimpleMessage( "GENERIC_LIST_NAME")));
				for (int i = 0; i < listNames.size(); i++) {
		%>
	
	<tr class=BgLight>
		<td><%=listUsers.get(i)%></td>
		<td><%=listNames.get(i)%></td>
	</tr>
	<%
		}
	%>
</table>
<p><%= LocalizedMessage.getSimpleMessage( "ARE_YOU_SURE" ) %><br>

<%
	} // BatchDel
	else {
		throw new imagemed.exception.IMException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FOLDEROP_UNKNOWN_OPER" ) + ": " + parOper );
	}

	is.out.println(reqPar.passAsFormExcept("cOper,parentwindow,cEnabled,cPrefetchLite,cAction,cSchedule,cEmail,cApplyToCurrent"));
	String img = parOper;
	if ("BatchDel".equals(img))
		img = "Delete";
	else if ("Override".equals(img))
		img = "OK";
	else if ("SummaryConfigure".equals(img))
		img = "Configure";
	else if( "SaveOverWriteActions".equals( img ) ) {
		img = "OK";
%>
		<input type="hidden" name="cContext" value="<%=backContext%>">
<%		
	}
	
	String cancelOp = "";
	if (backContext != null && backContext.length() > 0) {
		cancelOp = "?cContext="+backContext;
	}
	else if (isAdmin) {
		cancelOp = "?cListType=" + listType;
	}
%> <input type="hidden" name="cOper" value="<%=parOper%>">
</FORM>
<%

	if ( parOper.startsWith( "Configure" ) ) {
		DcAction[] actions = DcActionManager.getActions();
		for ( int i = 0; i < actions.length; i++ ) {
			if ( actions[ i ].getName().equals( parAct ) ) {
				actions[ i ].setList( parListUser, parListName );
				actions[ i ].printExtraButtons( is );
			}
		}
	}

%>
<a href="javascript:doSubmit()">
	<%= JSHelper.getJsLocalizedButton( "BUTTON_" + img.toUpperCase(), "BUTTON_NULL", false )  %>
</a>
<%
	if( "SaveOverWriteActions".equals( parOper ) ) {
%>
<A href="javascript:self.history.back();">
	<%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %>
</a>
<%
	}
	else {
%>
<a href="lists.jsp<%=cancelOp%>">
	<%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %>
</a>
<%
	}
%>
</center>
<%
	if ( parOper.startsWith( "Configure" ) ) {
		DcAction[] actions = DcActionManager.getActions();
		for ( int i = 0; i < actions.length; i++ ) {
			if ( actions[ i ].getName().equals( parAct ) ) {
				actions[ i ].setList( parListUser, parListName );
				actions[ i ].printMisc( is );
			}
		}
	}
%>
</body>
</html>
--%>