<%--
 * Component: cases
 *
 * Description:
 *    Updates the CacheState database table with the current loaded percent of studies on a workstation (viewer cache).
 *
 * Parameters:
 *    CacheInfo : cache information. Below is an example:
 *
 * *Example of input (CacheInfo)
 * Version PBS001
 * WorkstationID 193.68.54.149
 * StudyCount 3
 * StudyUID 999.999.3859744
 * StudyRate 50
 * StudyUID 1.2.840.113674.1115.261.200
 * StudyRate 100
 * StudyUID 1.2.840.113704.3.1.429231.343410.121952.38
 * StudyRate 33
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%>
<%
	response.setHeader( "protocolVersion", "1" );
	response.setHeader( "sendUpdates", "false" ); // tell newer viewers not to send updates at all
	return;
	
//	try {
//		String inputString = getInput(request);
//	//	workstationID = getWorkstationID(sess);
//		Helper.DEBUG("updatecachestate.jsp", "workstationID="+workstationID);
//		if (workstationID == null || "".equals(workstationID)) {
//			throw new IMException("Empty workstation ID Error");
//		}
//		rateOfStudies = getRateOfStudies(inputString);
//		
//		// query current state
//		Connection imDB = IMEnv.getDB();
//		Statement prev = imDB.createStatement();
//		Set<String> removedStudies = new HashSet<String>();
//		ResultSet rs = prev.executeQuery("SELECT SRCSTUDY, LOADED FROM " + cacheTable + " WHERE WSID='" + workstationID + "'");
//		while (rs.next()) {
//			String study = rs.getString("SRCSTUDY");
//			if (!rateOfStudies.containsKey(study)) {
//				// removed from cache
//				removedStudies.add(study);
//			}
//			else {
//				Integer loaded = new Integer( rs.getInt("LOADED") );
//				if (loaded.equals(rateOfStudies.get(study))) {
//					// did not change
//					rateOfStudies.remove(study);
//				}
//			}
//		}
//		Statement del = imDB.createStatement();
//		int count = 0;
//		StringBuffer deleteClause = new StringBuffer("");
//		for (String study : removedStudies) {
//			if (count++ == 0) {
//				deleteClause = new StringBuffer(deleteClause.capacity());
//				deleteClause.append("DELETE FROM " + cacheTable + " WHERE WSID='" + workstationID + "' AND SRCSTUDY in (");
//			}
//			deleteClause.append("'"+study+"',");
//			if (count == 40) {
//				del.executeUpdate(deleteClause.substring(0, deleteClause.length()-1)+")");
//				count = 0;
//			}
//		}
//		if (count > 0) {
//			del.executeUpdate(deleteClause.substring(0, deleteClause.length()-1)+")");
//		}
//		
//		PreparedStatement repl = imDB.prepareStatement("REPLACE INTO " + cacheTable + " ( WSID, SRCSTUDY, LOADED ) VALUES ('" + workstationID + "',?,?)");
//		for (String uid : rateOfStudies.keySet()) {
//			repl.setString(1, uid);
//			Integer rate = rateOfStudies.get(uid);
//			repl.setInt(2, rate.intValue() );
//			repl.executeUpdate();
//		}
//	}
//	catch (Throwable t) {
//		is.out.println("FAILED - " + t.getMessage());
//	}
//
//	response.getWriter(  ).println("OK");
//
//	if (true) {
//		// For avoiding extra newline(s)
//		return;
//	}

%>