#!/bin/sh
#
# Component: cases
#
# Purpose:
#     Handles STUDYDIR released events
#
# Usage:
#    onStudydirReleased.sh -t <type> -e <event> -i <id>
#
#    -t type  : Object type to be released. It will always be "STUDYDIR"
#    -e event : Event triggered runiing this script. It will always be "RELASED"
#    -i id    : Identifies the studydb object (=Study Instance UID)
#
# Description:
#     Will be called when a STUDYDIR reference counter is released.
# The study directory with all content will be removed.
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

command="imagemed.taskd.TestTask2"

$TASKD_HOME/runjavacmd -c "0 $command" -p $JAVA_SERVER_PORT

#$TASKD_HOME/createtaskfileapp -p "CALLBACK_HOOK" -c "imagemed.taskd.TestTask" -t "class" 
