<%--
 * Component: checkintegrity
 *
 * Description:
 *   Start resynchronizing a study toward Consolidation Worklist server
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="java.io.*,java.util.*, imagemed.dotcom.DotcomConfig, imagemed.dotcom.StudySynchronizer,
			imagemed.jsputil.DotcomToolbox"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

	/**
	 * Prints result to output writer in a processable format
	 *
	 * @param out      Output writer to print result on
	 * @param result   Result to be written
	 * @param message  Additional message to be written if any 
	 */
	static void printResult(JspWriter out, String result, String message) throws IOException {
		out.println("#RESULT: " + result);
		if (message != null) {
			out.println("#MESSAGE: " + message);
		}
	}

%><%
	response.setContentType("text/plain");

	//IMSession is = new IMSession(request, response, out);

	// Stud Instance UID of the study to be fixed
	String parStudy         = request.getParameter("cStudy");

	String peerId = null;
	try {
		Properties prpDevice = DotcomToolbox.checkClient(request.getRemoteAddr(),"P");
		peerId = prpDevice.getProperty("ID");
	}
	catch (Throwable th) {
	}

	if (peerId == null) {
		printResult(out, "ERROR", "Peer is not recognized or is not a parent server");
		return;
	}

	if (parStudy == null) {
		printResult(out, "ERROR", "Missing parameter: cStudy");
		return;
	}

	if (!DotcomConfig.isParentDbOnly()) {
		printResult(out, "ERROR", "Parent is not a Consolidation Worklist server");
		return;
	}

	// Force synchronization
	StudySynchronizer.runTask( null, parStudy, true );

	printResult(out, "OK", null);
%>
